--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
class CALC_WINDOW inherit
      BEOS_WINDOW
         rename
            size as window_size
         end

creation make

feature {NONE}

   Num_btns_across : INTEGER is 10
   Num_btns_down   : INTEGER is 4

   btn_add   : ADD_BUTTON
   btn_sub   : SUB_BUTTON
   btn_mult  : MULT_BUTTON
   btn_div   : DIV_BUTTON
   btn_enter : ENTER_BUTTON

   btn_0  : DIGIT_BUTTON   -- how much is that button in the window?
   btn_1  : DIGIT_BUTTON
   btn_2  : DIGIT_BUTTON
   btn_3  : DIGIT_BUTTON
   btn_4  : DIGIT_BUTTON
   btn_5  : DIGIT_BUTTON
   btn_6  : DIGIT_BUTTON
   btn_7  : DIGIT_BUTTON
   btn_8  : DIGIT_BUTTON
   btn_9  : DIGIT_BUTTON
   btn_a  : DIGIT_BUTTON
   btn_b  : DIGIT_BUTTON
   btn_c  : DIGIT_BUTTON
   btn_d  : DIGIT_BUTTON
   btn_e  : DIGIT_BUTTON
   btn_f  : DIGIT_BUTTON
   btn_dp : DIGIT_BUTTON  -- decimal point

   make is
      local
         btn_size       : BEOS_RECTANGLE_SIZE
         enter_btn_size : BEOS_RECTANGLE_SIZE
         btn_corner     : BEOS_POINT
         btn_offset     : BEOS_POINT
         btn_spacing    : BEOS_POINT
      do
         !!btn_size.make(32.0, 24.0)  -- define the size of the buttons
         !!btn_spacing.make(4.0, 4.0) -- and the space between them
         !!enter_btn_size.make(btn_size.width, btn_size.height*2.0 + btn_spacing.y)

         !!btn_offset.make(btn_size.width + btn_spacing.x,
                              btn_size.height + btn_spacing.y)

         !!window_size.make(btn_offset.x * Num_btns_across,
                            btn_offset.y * Num_btns_down + 40.0)
         !!corner.make(100.0, 80.0)  -- define the upper left corner of the window

         title := "RPN Calc"    -- title of the window
         movable := True             -- must set any of
         closable := True            --          the attributes we
         minimizable := True         --                   want enabled to true
         make_titled                 -- create the window

         !!btn_corner.make(btn_spacing.x / 2.0,
                           btn_spacing.y / 2.0 + 40.0) -- upper left of first
         !!btn_a.make(Current, btn_corner, btn_size, 'A')
         btn_corner.move_right(btn_offset.x)
         !!btn_b.make(Current, btn_corner, btn_size, 'B')
         btn_corner.move_right(btn_offset.x)
         !!btn_c.make(Current, btn_corner, btn_size, 'C')
         btn_corner.move_right(btn_offset.x)
         !!btn_d.make(Current, btn_corner, btn_size, 'D')
         btn_corner.move_right(btn_offset.x)
         !!btn_e.make(Current, btn_corner, btn_size, 'E')
         btn_corner.move_right(btn_offset.x)
         !!btn_f.make(Current, btn_corner, btn_size, 'F')
         btn_corner.move_right(btn_offset.x)
         !!btn_7.make(Current, btn_corner, btn_size, '7')
         btn_corner.move_right(btn_offset.x)
         !!btn_8.make(Current, btn_corner, btn_size, '8')
         btn_corner.move_right(btn_offset.x)
         !!btn_9.make(Current, btn_corner, btn_size, '9')
         btn_corner.move_right(btn_offset.x)
         !!btn_div.make(Current, btn_corner, btn_size)

         btn_corner.move_down(btn_offset.y)
         !!btn_mult.make(Current, btn_corner, btn_size)
         btn_corner.move_left(btn_offset.x)
         !!btn_6.make(Current, btn_corner, btn_size, '6')
         btn_corner.move_left(btn_offset.x)
         !!btn_5.make(Current, btn_corner, btn_size, '5')
         btn_corner.move_left(btn_offset.x)
         !!btn_4.make(Current, btn_corner, btn_size, '4')

         btn_corner.move_down(btn_offset.y)

         btn_corner.move_left(btn_offset.x)
         !!btn_enter.make(Current, btn_corner, enter_btn_size)
         btn_corner.move_right(btn_offset.x)

         !!btn_1.make(Current, btn_corner, btn_size, '1')
         btn_corner.move_right(btn_offset.x)
         !!btn_2.make(Current, btn_corner, btn_size, '2')
         btn_corner.move_right(btn_offset.x)
         !!btn_3.make(Current, btn_corner, btn_size, '3')
         btn_corner.move_right(btn_offset.x)
         !!btn_sub.make(Current, btn_corner, btn_size)
         btn_corner.move_down(btn_offset.y)
         !!btn_add.make(Current, btn_corner, btn_size)
         btn_corner.move_left(btn_offset.x * 2.0)
         !!btn_dp.make(Current, btn_corner, btn_size, '.')
         btn_corner.move_left(btn_offset.x)
         !!btn_0.make(Current, btn_corner, btn_size, '0')

         show  -- display the window
      end;

   verify_close : BOOLEAN is
	  do
	     This_app.post_quit_request
         Result := True
	  end;

end -- CALC_WINDOW

