--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
class MY_WINDOW inherit
      BEOS_WINDOW

creation make

feature {NONE}

   button_1 : MY_IDEA_BUTTON   -- these will be the buttons in the window
   button_2 : MY_INFO_BUTTON
   button_3 : MY_STOP_BUTTON
   button_4 : MY_WARN_BUTTON
   button_5 : MY_QUIT_BUTTON

   make is
      local
         button_size   : BEOS_RECTANGLE_SIZE
         button_corner : BEOS_POINT
      do
         title := "My Eiffel App"    -- title of the window
         !!corner.make(100.0, 80.0)  -- define the upper left corner of the window
         !!size.make(120.0, 210.0)   -- define the size of the window
         movable := True             -- must set any of
         closable := True            --          the attributes we
         minimizable := True         --                   want enabled to true
         make_titled                 -- create the window

         !!button_size.make(100.0, 30.0) -- define the size of the buttons

         !!button_corner.make(10.0, 10.0) -- upper left corner of first button
         !!button_1.make(Current, button_corner, button_size)
         button_corner.move_down(40.0)
         !!button_2.make(Current, button_corner, button_size)
         button_corner.move_down(40.0)
         !!button_3.make(Current, button_corner, button_size)
         button_corner.move_down(40.0)
         !!button_4.make(Current, button_corner, button_size)
         button_corner.move_down(40.0)
         !!button_5.make(Current, button_corner, button_size)

         show  -- display the window
      end;

   verify_close : BOOLEAN is
     -- this routine is called when the user has requested the window be closed
	  local
		  alert : BEOS_STOP_ALERT;
		  key   : STRING;
	  do
         !!alert.make_2_button("Are you sure you want to close this?", "No", "Yes");
		 key := alert.display;

         if equal(key,"Yes") then
            This_app.post_quit_request;
            Result := True
         end;
	  end;

end -- MY_WINDOW

