--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
deferred class B_ALERT
   --   
   -- Access the BAlert class in BeOS
   --

feature 
   
   go : INTEGER is
      -- returns one for the first button (left most), two for the second ...
      do
         Result  := b_alert_go(this)
      end;


feature {NONE}

   Empty   : INTEGER is 0;   -- note this *MUST* match the array in b_alert.cpp
   Info    : INTEGER is 1;
   Idea    : INTEGER is 2;
   Warning : INTEGER is 3;
   Stop    : INTEGER is 4;

   this    : POINTER;

   construct_1(text, one : STRING; type : INTEGER) is
     -- construct an alert box with one button
      do
         this := b_alert_construct_1(text.to_external, one.to_external, type)
      end;

   construct_2(text, one, two : STRING; type : INTEGER) is
     -- construct an alert box with two buttons
      do
         this := b_alert_construct_2(text.to_external,
                                     one.to_external,
                                     two.to_external,
                                     type)
      end;

   construct_3(text, one, two, three : STRING; type : INTEGER) is
     -- construct an alert box with three buttons
      do
         this := b_alert_construct_3(text.to_external,
                                     one.to_external,
                                     two.to_external,
                                     three.to_external,
                                     type)
      end;

feature {NONE}  -- Access external C routines

  -- Note: could not get it to accept Void for a pointer so these had to be
  --       separated into 3 different routines based on how many buttons.

   b_alert_construct_1(txt, one: POINTER; type: INTEGER) : POINTER is
    -- Receive the this pointer from C
      external "C_WithoutCurrent"
      end;

   b_alert_construct_2(txt, one, two: POINTER; type: INTEGER) : POINTER is
    -- Receive the this pointer from C
      external "C_WithoutCurrent"
      end;

   b_alert_construct_3(txt, one, two, three: POINTER; type: INTEGER) : POINTER is
    -- Receive the this pointer from C
      external "C_WithoutCurrent"
      end;

   b_alert_go(t : POINTER) : INTEGER is
      external "C_WithoutCurrent"
      end;

end -- B_ALERT

