//*****************************************************************************
// b_button.cpp - functions to allow Small Eiffel to access the BeOS BButton
//
//           This file is part of the SmallEiffel BeOS Library.
//                  Copyright (C) 1998 Lost Alternative
//                J. Scott Edwards - sedwards@xmission.com 
//
//  This is  free  software;  you can  redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the
//  Free Software Foundation;  either  version  2, or (at your option) any
//  later verson.  It is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for  more  details.  You  should  have  received
//  a copy of the GNU General Public  License  along  with this software;
//  see the file COPYING.  If not, write to the  Free Software Foundation,
//  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  The original source code for SmallEiffel can be found at
//             http://www.loria.fr/SmallEiffel
//
//*****************************************************************************

#include <Button.h>

#ifdef DEBUG
#include <stdio.h>
#endif


////////////////////////////////////////////////////////////////////////////////
// C Function called by Small Eiffel to construct a button
////////////////////////////////////////////////////////////////////////////////

extern "C" BButton* b_button_construct(
    void*       target,
    void        (*acb)(void*),
    BRect*      frame,
    const char* name,
    const char* label);

BButton* b_button_construct(
    void*       target,
    void        (*acb)(void*),
    BRect*      frame,
    const char* name,
    const char* label)
{
   // Note: this BMessage *MUST* be created by 'new' because the BMessage becomes
   //       the property of BControl (which BButton is derived from) and it expects
   //       it to have been allocated.  This is one of the reasons I don't like
   //       C++ because I have to deal with this stuff.
    BMessage* msg = new BMessage('bttn');    // create a BMessage
    msg->AddInt32("target", (int32)target);  // and insert the target and callback
    msg->AddInt32("callback", (int32)acb);

    BButton* theButton = new BButton(*frame, name, label, msg);
#ifdef DEBUG
    printf("b_button_construct(%f %f %f %f  %s %s)->%08x\n",
      frame->left, frame->top, frame->right, frame->bottom, name, label,theButton);
#endif
    return theButton;
}


