--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
class B_BUTTON
   --   
   -- Access the BButton class in BeOS
   --

feature  -- Implementation

   this : POINTER;

feature {NONE}  -- creation

   construct(frame : B_RECT; name, label : STRING) is
      do
         this := b_button_construct($button_message,
                                    frame.this,
                                    name.to_external,
                                    label.to_external)
      end;

feature {NONE}  -- Access external C routines

   b_button_construct(callback, frame, name, label : POINTER) : POINTER is
    -- Receive the this pointer from C
      external "C_WithCurrent"
      end;


feature {NONE} -- callback routines

   button_message is   -- called when BWindow receives the 'bttn' message 
      deferred
      end;

end -- B_BUTTON

