//*****************************************************************************
//  b_rect.cpp - functions to allow Small Eiffel to access the BeOS BRect
//
//           This file is part of the SmallEiffel BeOS Library.
//                  Copyright (C) 1998 Lost Alternative
//                J. Scott Edwards - sedwards@xmission.com 
//
// This is  free  software;  you can  redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation;  either  version  2, or (at your option) any
// later verson.  It is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for  more  details.  You  should  have  received
// a copy of the GNU General Public  License  along  with this software;
// see the file COPYING.  If not, write to the  Free Software Foundation,
// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// The original source code for SmallEiffel can be found at
//             http://www.loria.fr/SmallEiffel
//
//*****************************************************************************

#include <Rect.h>

#ifdef DEBUG
#include <stdio.h>  // for debugging
#endif


////////////////////////////////////////////////////////////////////////////////
// Function to construct a BRect
////////////////////////////////////////////////////////////////////////////////

extern "C" BRect* b_rect_construct(float left, float top, float right, float bottom);

BRect* b_rect_construct(float left, float top, float right, float bottom)
{
    BRect* theRect = new BRect(left, top, right, bottom);
    return theRect;
}


////////////////////////////////////////////////////////////////////////////////
// Functions to access the data members of the BRect
////////////////////////////////////////////////////////////////////////////////

extern "C" float b_rect_left(BRect* theRect);

float b_rect_left(BRect* theRect)
{
    return theRect->left;
}


extern "C" float b_rect_top(BRect* theRect);

float b_rect_top(BRect* theRect)
{
    return theRect->top;
}


extern "C" float b_rect_right(BRect* theRect);

float b_rect_right(BRect* theRect)
{
    return theRect->right;
}


extern "C" float b_rect_bottom(BRect* theRect);

float b_rect_bottom(BRect* theRect)
{
    return theRect->bottom;
}


////////////////////////////////////////////////////////////////////////////////
// Functions to access the width and height of BRect
////////////////////////////////////////////////////////////////////////////////

extern "C" float b_rect_width(BRect* theRect);

float b_rect_width(BRect* theRect)
{
    return theRect->Width();
}


extern "C" float b_rect_height(BRect* theRect);

float b_rect_height(BRect* theRect)
{
    return theRect->Height();
}


////////////////////////////////////////////////////////////////////////////////
// Functions to offset the position of the BRect
////////////////////////////////////////////////////////////////////////////////

extern "C" void b_rect_offset_by(BRect* theRect, float horizontal, float vertical);

void b_rect_offset_by(BRect* theRect, float horizontal, float vertical)
{
    theRect->OffsetBy(horizontal, vertical);
}


////////////////////////////////////////////////////////////////////////////////
// Function to destruct a BRect
////////////////////////////////////////////////////////////////////////////////

extern "C" void b_rect_destruct(BRect* theRect);

void b_rect_destruct(BRect* theRect)
{
#ifdef DEBUG
    printf("b_rect_destruct(%08x)\n");
#endif
    delete theRect;
}


