--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
deferred class B_WINDOW
   --   
   -- Access the BWindow class in BeOS
   --

feature 
   
   show is
      do
         b_window_show(this);
      end;

   add_child(a_view : POINTER) is
      do
         b_window_add_child(this, a_view)
      end;

feature {NONE}

   Modal    : INTEGER is 0;   -- note these *MUST* match the array in b_window.cpp
   Bordered : INTEGER is 1;
   Titled   : INTEGER is 2;
   Document : INTEGER is 3;

   this     : POINTER;
   
   construct(frame : B_RECT;
             title : STRING;
             type  : INTEGER;
             movable, resizable, closable, zoomable, minimizable : BOOLEAN) is
      do
        this := b_window_construct($quit_requested,
                                   $message_received,
                                   frame.this,
                                   title.to_external,
                                   type,
                                   movable,
                                   resizable,
                                   closable,
                                   zoomable,
                                   minimizable)
      end;


feature {NONE}  -- Calls to external C routines

   b_window_construct(qrcb, mrcb         : POINTER;
                      frame              : POINTER;
                      title              : POINTER;
                      type               : INTEGER;
                      mv, rz, cl, zm, mn : BOOLEAN) : POINTER is
    -- Receive the this pointer from C
      external "C_WithCurrent"
      end;

   b_window_show(t : POINTER) is
      external "C_WithoutCurrent"
      end;

   b_window_add_child(window, view : POINTER) is
      external "C_WithoutCurrent"
      end;


feature {NONE} -- callback routines

   quit_requested : BOOLEAN is
      deferred
      end;

   message_received(msg : INTEGER) is
      deferred
      end;

end -- B_WINDOW

