--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
deferred class BEOS_ALERT inherit
               B_ALERT
   --   
   -- Access the BAlert class in BeOS
   --

feature 
   
   display : STRING is
      -- returns the label given for the button as it's identifier
      local
         button_number : INTEGER;
      do
         button_number := go;
         Result := label.item(button_number);
      end;


feature {NONE}

   label   : ARRAY[STRING];

   make_1(type : INTEGER; text, button : STRING) is
     -- make an alert box with one button
      do
         !!label.make(1,1)
         label.put(button, 1)
         construct_1(text, button, type)
      end;

   make_2(type : INTEGER; text, left_button, right_button : STRING) is
     -- make an alert box with two buttons
      do
         !!label.make(1,2)
         label.put(left_button,  1)
         label.put(right_button, 2)
         construct_2(text, left_button, right_button, type)
      end;

   make_3(type : INTEGER;
          text : STRING;
          left_button, middle_button, right_button : STRING) is
     -- make an alert box with three buttons
      do
         !!label.make(1,3);
         label.put(left_button,   1);
         label.put(middle_button, 2);
         label.put(right_button,  3);
         construct_3(text, left_button, middle_button, right_button, type);
      end;

end -- BEOS_ALERT

