--              This file is part of the SmallEiffel BeOS Library.
--                    Copyright (C) 1998 Lost Alternative
--                  J. Scott Edwards - sedwards@xmission.com
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
--
class BEOS_BUTTON inherit
      B_BUTTON
   --   
   -- Create a Button in the given window
   --
creation
   make

feature

   label : STRING
   
feature {NONE}

   activated is  -- this routine is called when the button has been activated
      do
         std_output.put_string("BEOS_BUTTON:")
         std_output.put_string(label)
         std_output.put_string(":activated%N")
      end;

feature {NONE}  -- Creation
   
   make(window : BEOS_WINDOW; corner : BEOS_POINT; size : BEOS_RECTANGLE_SIZE) is
      require
         label /= Void
         window /= Void
         corner /= Void
         size /= Void
      local
         frame : BEOS_RECTANGLE
      do
         !!frame.make(corner, size)
         construct(frame, "Button X", label)
         window.add_child(this)
      end;

feature {NONE}  -- Effect the callback from the external routines

   button_message is
      do
         activated  -- call the routine to be defined by the heirs
      end;

end -- BEOS_BUTTON

