--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
class BEOS_POINT
   --   
   -- define a point
   --

creation make

feature -- Access

   x, y : REAL

feature -- Movement

   move_left(amount : REAL) is
      require
         positive_amount: amount > 0.0
         not_too_far_left: amount <= x
      do
         x := x - amount
      end;

   move_up(amount : REAL) is
      require
         positive_amount: amount > 0.0
         not_too_far_up: amount <= y
      do
         y := y - amount
      end;

   move_right(amount : REAL) is
      require
         positive_amount: amount > 0.0
      do
         x := x + amount
      end;

   move_down(amount : REAL) is
      require
         positive_amount: amount > 0.0
      do
         y := y + amount
      end;


feature {NONE}

   make(initial_x, initial_y : REAL) is
      do
         x := initial_x
         y := initial_y
      end;

invariant
   x >= 0.0
   y >= 0.0

end -- BEOS_POINT

