--           This file is part of the SmallEiffel BeOS Library.
--                  Copyright (C) 1998 Lost Alternative
--                J. Scott Edwards - sedwards@xmission.com 
--
-- This is  free  software;  you can  redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation;  either  version  2, or (at your option) any
-- later verson.  It is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- General Public License for  more  details.  You  should  have  received
-- a copy of the GNU General Public  License  along  with this software;
-- see the file COPYING.  If not, write to the  Free Software Foundation,
-- Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--
-- The original source code for SmallEiffel can be found at
--             http://www.loria.fr/SmallEiffel
--
--
class BEOS_RECTANGLE inherit
      B_RECT
   --   
   -- define a rectangle
   --

creation make


feature -- Movement

   move_left(amount : REAL) is
      require
         positive_amount: amount > 0.0
         not_too_far_left: amount <= left
      do
         offset_by(-amount, 0.0)
      end;

   move_up(amount : REAL) is
      require
         positive_amount: amount > 0.0
         not_too_far_up: amount <= top
      do
         offset_by(0.0, -amount)
      end;

   move_right(amount : REAL) is
      require
         positive_amount: amount > 0.0
      do
         offset_by(amount, 0.0)
      end;

   move_down(amount : REAL) is
      require
         positive_amount: amount > 0.0
      do
         offset_by(0.0, amount)
      end;


feature {NONE}

   make(upper_left_corner : BEOS_POINT; size : BEOS_RECTANGLE_SIZE) is
      do
         construct(upper_left_corner.x,
                   upper_left_corner.y,
                   upper_left_corner.x + size.width,
                   upper_left_corner.y + size.height)
      end;

invariant
   width >= 0.0
   height >= 0.0

end -- BEOS_RECTANGLE

